program cht;

type
		PointPtr=^TPoint;
		TPoint=record
			X:integer;
			Y:integer;
			C,H,N,O,P,S,Si,B,Br,Cl,F,I,Na,K:integer;
			RecCount:integer;
			Last:PointPtr;
		end;
				 
var C,H,N,O,P,S,Si,B,Br,Cl,F,I,Na,K,X1,X2,Y1,Y2,T:Integer;
		IFile:text;
		Point,Last,Current:PointPtr;
		sss,A,subs,Bondss,Labelss:string;
		M:real;
		Count,code,atoms,rep:integer;
		Abandon,debug,verbose,exact,fa:boolean;

Procedure doBonds;
begin
	 Readln(IFile,sss);
	 Repeat
		 if debug then Writeln(sss);
		 Val(Copy(sss,1,Pos(#09,sss)-1),X1,code);
		 sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		 Val(Copy(sss,1,Pos(#09,sss)-1),Y1,code);
		 sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		 Val(Copy(sss,1,Pos(#09,sss)-1),X2,code);
		 sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		 Val(Copy(sss,1,Pos(#09,sss)-1),Y2,code);
		 sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		 Val(Copy(sss,1,Length(sss)),T,code);
		
		 Abandon:=false;
		 Current:=Point;
		 While Point^.Last<>nil  do
			 begin
				 If (Point^.X=X1) AND (Point^.Y=Y1) then
					 begin
						 if debug then Writeln('  ',Point^.RecCount,' --> Joined at ',X1,' ',Y1);
						 If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=Point^.H-1;
						 If (T=1) OR (T=2) OR (T=4) then Point^.H:=Point^.H-2;
						 If (T=3) then Point^.H:=Point^.H-3;
						 Abandon:=true;
					 end;
				 Point:=Point^.Last;
			 end;
		 Point:=Current;
 
		 If Not Abandon then
			 begin
				 Inc(Count);
				 Last:=Point;  
				 New(Point);
				 Point^.X:=X1;
				 if debug then Write(' Point^.X: ',Point^.X);
				 Point^.Y:=Y1;
				 if debug then Write(' Point^.Y: ',Point^.Y);
				 Point^.C:=1;
				 if debug then Write(' Point^.C: ',Point^.C);
				 If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=3;
				 If (T=1) OR (T=2) OR (T=4) then Point^.H:=2;
				 If (T=3) then Point^.H:=1;
				 if debug then Write(' Point^.H: ',Point^.H);
				 Point^.N:=0;
				 Point^.O:=0;
				 Point^.P:=0;
				 Point^.S:=0;
				 Point^.Si:=0;
				 Point^.B:=0;
				 Point^.Br:=0;
				 Point^.Cl:=0;
				 Point^.F:=0;
				 Point^.I:=0;
				 Point^.Na:=0;
				 Point^.K:=0;
				 Point^.RecCount:=Count;
				 if debug then Writeln('Point^.RecCount: ',Point^.RecCount);
				 Point^.Last:=Last;
			 end;
 
		 Abandon:=false;
		 Current:=Point;
		 While Point^.Last<>nil  do
			 begin
				 If (Point^.X=X2) AND (Point^.Y=Y2) then 
					 begin
						 if debug then Writeln('  ',Point^.RecCount,' --> Joined at ',X2,' ',Y2);
						 If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=Point^.H-1;
						 If (T=1) OR (T=2) OR (T=4) then Point^.H:=Point^.H-2;
						 If (T=3) then Point^.H:=Point^.H-3;
						 Abandon:=true;
					 end;
				 Point:=Point^.Last;
			 end;
		 Point:=Current;
		 
		 If Not Abandon then
			 begin
				 Inc(Count);
				 Last:=Point;  
				 New(Point);
				 Point^.X:=X2;
				 if debug then Write(' Point^.X: ',Point^.X);
				 Point^.Y:=Y2;
				 if debug then Write(' Point^.Y: ',Point^.Y);
				 Point^.C:=1;
				 if debug then Write(' Point^.C: ',Point^.C);
				 If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=3;
				 If (T=1) OR (T=2) OR (T=4) then Point^.H:=2;
				 If (T=3) then Point^.H:=1;
				 if debug then Write(' Point^.H: ',Point^.H);
				 Point^.N:=0;
				 Point^.O:=0;
				 Point^.P:=0;
				 Point^.S:=0;
				 Point^.Si:=0;
				 Point^.B:=0;
				 Point^.Br:=0;
				 Point^.Cl:=0;
				 Point^.F:=0;
				 Point^.I:=0;
				 Point^.Na:=0;
				 Point^.K:=0;
				 Point^.RecCount:=Count;
				 if debug then Writeln('Point^.RecCount: ',Point^.RecCount);
				 Point^.Last:=Last;
			 end;
 
		 Readln(IFile,sss);
	 Until NOT (sss[1] IN ['0'..'9']);
end;

Procedure doLabels;
var mul,gmul,gmpos,ggmul,ggmpos,code:integer;
begin
	If debug then Writeln('---- and now parse the labels ---------');
	If Copy(sss,1,Pos(' ',sss)-1)='atoms' then
		begin
			Val(Copy(sss,Pos(' ',sss),Length(sss)-Pos(' ',sss)+1),atoms,code);
			If verbose then Writeln ('HeteroAtoms: ',atoms);	
		end;
	For rep:= 1 to atoms do
		begin
			Readln(IFile,sss);
			Val(Copy(sss,1,Pos(#09,sss)-1),X1,code);
			sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
			Val(Copy(sss,1,Pos(#09,sss)-1),Y1,code);
			sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
			A:=Copy(sss,1,Pos(#09,sss)-1);
			
			If debug then Writeln('Atom ',A, ' X=',X1,' Y=',Y1,' sss: ',sss);		
			Current:=Point;
			While Point^.Last<>nil  do
				begin
					If (Point^.X=X1) AND (Point^.Y=Y1) then
						begin
							If debug then Writeln('  ',Point^.RecCount,' --> Heteroatom ',X1,' ',Y1);
							Point^.C:=0;{we substitute -CH_x(-) by -R(-)}	
							Point^.H:=0;
							mul:=1;
							gmul:=1;ggmul:=1;
							gmpos:=0;ggmpos:=0;
							While A<>'' do
								begin
									If Length(A) >= 5 then 
										begin
											subs:=Copy(A,1,5);
											If Length(A)>6 then If A[6]='_' then Val(A[7],mul,code) else mul:=1;
											mul:=mul*gmul*ggmul;
											If subs='TBDMS' then
												begin {Tert-butyldimethylsilyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+6*mul;
													Point^.H:=Point^.H+15*mul;
													Point^.Si:=Point^.Si+1*mul;
													A:=Copy(A,6,Length(A)-5);
												end;
											If subs='TBDPS' then
												begin {Tert-butyldiphenylsilyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+16*mul;
													Point^.H:=Point^.H+19*mul;
													Point^.Si:=Point^.Si+1*mul;
													A:=Copy(A,6,Length(A)-5);
												end;
											If A[1]='[' then
												begin
													ggmpos:=Pos(']',A);
													If ggmpos <> 0 then If A[ggmpos+1] = '_' then Val(A[ggmpos+2],ggmul,code) else ggmul:=1;
												end;
											If A[1]='(' then
												begin
													gmpos:=Pos(')',A);
													If gmpos <> 0 then If A[gmpos+1] = '_' then Val(A[gmpos+2],gmul,code) else gmul:=1;
												end;
										end;
									If Length(A) >= 4 then
									  begin
										  subs:=Copy(A,1,4);
											If Length(A)>5 then If A[5]='_' then Val(A[6],mul,code) else mul:=1;
											mul:=mul*gmul*ggmul;
											If subs='DBAM' then
												begin {dibutylaminomethylene; =R, used as the N prot.}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+9*mul;
													Point^.H:=Point^.H+19*mul;
													Point^.N:=Point^.N+1*mul;
													A:=Copy(A,5,Length(A)-4);
												end;
											If subs='DMAM' then
												begin {dimethylaminomethylene; =R, used as the N prot.}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+3*mul;
													Point^.H:=Point^.H+7*mul;
													Point^.N:=Point^.N+1*mul;
													A:=Copy(A,5,Length(A)-4);
												end;
											If subs='DMTr' then
												begin {dimethoxytrityl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+21*mul;
													Point^.H:=Point^.H+19*mul;
													Point^.O:=Point^.O+2*mul;
													A:=Copy(A,5,Length(A)-4);
												end;
											If subs='MMTr' then
												begin {monomethoxytrityl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+20*mul;
													Point^.H:=Point^.H+16*mul;
													Point^.O:=Point^.O+1*mul;
													A:=Copy(A,5,Length(A)-4);
												end;
											If subs='TMTr' then
												begin {trimethoxytrityl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+22*mul;
													Point^.H:=Point^.H+22*mul;
													Point^.O:=Point^.O+3*mul;
													A:=Copy(A,5,Length(A)-4);
												end;
										end;
									If Length(A) >= 3 then
										begin
											subs:=Copy(A,1,3);
											If Length(A)>4 then If A[4]='_' then Val(A[5],mul,code) else mul:=1;
											mul:=mul*gmul*ggmul;
											If subs='Ade' then
												begin {Adeninyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+5*mul;
													Point^.H:=Point^.H+4*mul;
													Point^.N:=Point^.N+5*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='BOC' then
												begin {Butyloxycarbonyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+5*mul;
													Point^.H:=Point^.H+9*mul;
													Point^.O:=Point^.O+2*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='Cyt' then
												begin {Cytosinyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+4*mul;
													Point^.H:=Point^.H+4*mul;
													Point^.N:=Point^.N+3*mul;
													Point^.O:=Point^.O+1*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='Gua' then
												begin {Guaninyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+5*mul;
													Point^.H:=Point^.H+4*mul;
													Point^.N:=Point^.N+5*mul;
													Point^.O:=Point^.O+1*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='iBu' then
												begin {iso-Butyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+4*mul;
													Point^.H:=Point^.H+9*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='iPr' then
												begin {2-Propyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+3*mul;
													Point^.H:=Point^.H+7*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='MOC' then
												begin {Methoxycarbonyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+2*mul;
													Point^.H:=Point^.H+3*mul;
													Point^.O:=Point^.O+2*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='MOM' then
												begin {Methoxymethyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+2*mul;
													Point^.H:=Point^.H+5*mul;
													Point^.O:=Point^.O+1*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='tBu' then
												begin {t-Butyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+4*mul;
													Point^.H:=Point^.H+9*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='Thy' then
												begin {Thyminyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+5*mul;
													Point^.H:=Point^.H+5*mul;
													Point^.N:=Point^.N+2*mul;
													Point^.O:=Point^.O+2*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='TMS' then
												begin {Trimethylsilyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+3*mul;
													Point^.H:=Point^.H+9*mul;
													Point^.Si:=Point^.Si+1*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='Tol' then
												begin {tolyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+8*mul;
													Point^.H:=Point^.H+7*mul;
													Point^.O:=Point^.O+1*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
											If subs='Ura' then
												begin {Uracilyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+4*mul;
													Point^.H:=Point^.H+3*mul;
													Point^.N:=Point^.N+2*mul;
													Point^.O:=Point^.O+2*mul;
													A:=Copy(A,4,Length(A)-3);
												end;
										end;
									If Length(A) >= 2 then
										begin
											subs:=Copy(A,1,2);
											If Length(A)>3 then If A[3]='_' then Val(A[4],mul,code) else mul:=1;
											mul:=mul*gmul*ggmul;
											If subs='Ac' then
												begin {acetyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+1*mul;
													Point^.H:=Point^.H+3*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Bn' then
												begin {benzyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+7*mul;
													Point^.H:=Point^.H+7*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Br' then
												begin {bromine}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.Br:=Point^.Br+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Bu' then
												begin {butyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+4*mul;
													Point^.H:=Point^.H+9*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Bz' then
												begin {benzoyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+7*mul;
													Point^.H:=Point^.H+5*mul;
													Point^.O:=Point^.O+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='CE' then
												begin {cyanoethyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+3*mul;
													Point^.H:=Point^.H+4*mul;
													Point^.N:=Point^.N+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Cl' then
												begin {chlorine}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.Cl:=Point^.Cl+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Et' then
												begin {ethyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+2*mul;
													Point^.H:=Point^.H+5*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Me' then
												begin {methyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+1*mul;
													Point^.H:=Point^.H+3*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Ms' then
												begin {methanesulfonyl, mesyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+1*mul;
													Point^.H:=Point^.H+3*mul;
													Point^.O:=Point^.O+2*mul;
													Point^.S:=Point^.S+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Na' then
												begin {sodium}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.Na:=Point^.Na+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Ph' then
												begin {phenyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+6*mul;
													Point^.H:=Point^.H+5*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Pr' then
												begin {propyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+3*mul;
													Point^.H:=Point^.H+7*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Tf' then
												begin {trifluoromethanesulfonyl, triflyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+1*mul;
													Point^.F:=Point^.F+3*mul;
													Point^.O:=Point^.O+2*mul;
													Point^.S:=Point^.S+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Tr' then
												begin {trityl, triphenylmethyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+19*mul;
													Point^.H:=Point^.H+15*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Ts' then
												begin {toluenesulfonyl, tosyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+7*mul;
													Point^.H:=Point^.H+7*mul;
													Point^.O:=Point^.O+2*mul;
													Point^.S:=Point^.S+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
											If subs='Si' then
												begin {silicon}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.Si:=Point^.Si+1*mul;
													A:=Copy(A,3,Length(A)-2);
												end;
										end;
									If Length(A) >= 1 then
										begin
											subs:=Copy(A,1,1);
											If Length(A)>2 then If A[2]='_' then Val(A[3],mul,code) else mul:=1;
											mul:=mul*gmul*ggmul;
											If subs='B' then
												begin {boron}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.B:=Point^.B+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='C' then
												begin {carbon}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='F' then
												begin {fluorine}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.F:=Point^.F+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='H' then
												begin {hydrogen}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.H:=Point^.H+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='I' then
												begin {iodine}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.I:=Point^.I+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='K' then
												begin {potassium}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.K:=Point^.K+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='N' then
												begin {nitrogen}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.N:=Point^.N+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='O' then
												begin {oxygen}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.O:=Point^.O+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='P' then
												begin {phosphorus}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.P:=Point^.P+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='S' then
												begin {sulfur}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.S:=Point^.S+1*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs='Z' then
												begin {"Z", Benzyloxycarbonyl}
													If debug then Writeln(subs,'*',mul,' (',gmul,',',ggmul,')');	
													Point^.C:=Point^.C+8*mul;
													Point^.H:=Point^.H+7*mul;
													Point^.O:=Point^.O+2*mul;
													A:=Copy(A,2,Length(A)-1);
												end;
											If subs=')' then
												begin {reset gmul}
													gmul:=1;
												end;
											If subs=']' then
												begin {reset gmul,ggmul}
													gmul:=1;
													ggmul:=1;
												end;
											If NOT (subs[1] IN (['B'..'Z'])) then A:=Copy(A,2,Length(A)-1);
										end;
								end;
					end;
				Point:=Point^.Last;
		  end;
		Point:=Current;
	end;
end;

				
begin
	If (Paramcount=0) then
		begin
			Writeln('enter "cht -h" for help');
			Halt(0);
		end;
	C:=0;
	H:=0;
	N:=0;
	O:=0;
	P:=0;
	S:=0;Si:=0;B:=0;Br:=0;I:=0;Cl:=0;F:=0;Na:=0;K:=0;
	verbose:=false;
	debug:=false;
	exact:=false;
	fa:=false;{no file assigned}
	Count:=0;
	For rep:= 1 to Paramcount do
		begin
			If (Paramstr(rep)='-v') OR (Paramstr(rep)='--verbose') then verbose:=true;
			If (Paramstr(rep)='-d') OR (Paramstr(rep)='--debug') then debug:=true;
			If (Paramstr(rep)='-e') OR (Paramstr(rep)='--exact') then exact:=true;
			If (Paramstr(rep)='-h') OR (Paramstr(rep)='--help') then 
				begin
					Writeln('The Chemtool drawings analyzer 0.19');
      		Writeln('***   Gizmo Head Software   ***');
      		Writeln('    Radek Liboska (c) 2000');
					Writeln;
					Writeln('syntax: cht [-options] <filename.cht>');
					Writeln;
					Writeln('Recognize C,H,O,N,P,S,Si,B,Br,I,Cl,F,Na,K');
					Writeln('          Ac,Ade,Bn,Bu,Bz,BOC,Cyt,CE,DBAM,DMAM,DMTr,Et,Gua,iBu,iPr,Me,Ms,MOC,MOM,MMTr');
					Writeln('          Ph,Pr,tBu,Tf,Thy,Tol,Tr,Ts,TBDMS,TBDPS,TMS,TMTr,Ura,Z');
					Writeln('Can handle two levels of patentheses; e.g. P[OCH(CH_3)_2]_3');
					Writeln;
					Writeln('options:');
					Writeln('  -h or --help : this help');
					Writeln('  -e or --exact: calculate exact mass for MS');
					Writeln('  -v or --verbose : be verbose');
					Writeln('  -d or --debug : be more verbose');
					Writeln;
					Halt(0);
				end;
			If Paramstr(rep)[1]<>'-' then 
				begin
					Assign(IFile,Paramstr(rep));
					fa:=true;
				end;
		end;
	If not fa then
		begin
			Writeln('No file defined,  enter "cht -h" for help');
			Halt(1);
		end;
	Reset(IFile);
	New(Point);
	Point^.X:=0;
	Point^.Y:=0;
	Point^.C:=0;
	Point^.H:=0;
	Point^.N:=0;
	Point^.O:=0;
	Point^.P:=0;
	Point^.S:=0;
	Point^.Si:=0;
	Point^.B:=0;
	Point^.Br:=0;
	Point^.Cl:=0;
	Point^.F:=0;
	Point^.I:=0;
	Point^.Na:=0;
	Point^.K:=0;
	Point^.RecCount:=Count;
	Point^.Last:=nil;
	Readln(IFile,sss);
	If not (sss='Chemtool Version 1.2') then
		begin
			Writeln('Not a chemtool 1.2 file,  enter "cht -h" for help');
			Halt(2);
		end;
	Readln(IFile);
	Readln(IFile,sss);
	Bondss:=Copy(sss,7,Length(sss));
	If sss[7] <> '0' then doBonds else writeln('we do not calculate labels with no connection to any bond');
	Labelss:=Copy(sss,7,Length(sss));
	If sss[7] <> '0' then doLabels;

	
	Close(IFile);
	if verbose then Writeln('---------------------- Summary -------------------------');
	While Point^.Last<>nil  do
		begin
			if verbose then Writeln('RecCount: ',Point^.RecCount,' X=',Point^.X,' Y=',Point^.Y,' C',Point^.C,' H',Point^.H,' N',Point^.N,' O',Point^.O,' P',Point^.P,' S',Point^.S,' Si',Point^.Si,' B',Point^.B,' Br',Point^.Br,' Cl',Point^.Cl,' F',Point^.F,' I',Point^.I,' Na',Point^.Na,' K',Point^.K);
			C:=C+Point^.C;
			H:=H+Point^.H;
			N:=N+Point^.N;
			O:=O+Point^.O;
			P:=P+Point^.P;
			S:=S+Point^.S;
			Si:=Si+Point^.Si;
			B:=B+Point^.B;
			Br:=Br+Point^.Br;
			Cl:=Cl+Point^.Cl;
			F:=F+Point^.F;
			I:=I+Point^.I;
			Na:=Na+Point^.Na;
			K:=K+Point^.K;

			Point:=Point^.Last;
		end;	
	If C>1 then Write('C',C);If C=1 then Write('C');
	If H>1 then Write('H',H);If H=1 then Write('H');
	If N>1 then Write('N',N);If N=1 then Write('N');
	If O>1 then Write('O',O);If O=1 then Write('O');
	If P>1 then Write('P',P);If P=1 then Write('P');
	If S>1 then Write('S',S);If S=1 then Write('S');
	If Si>1 then Write('Si',Si);If Si=1 then Write('Si');
	If B>1 then Write('B',B);If B=1 then Write('B');
	If Br>1 then Write('Br',Br);If Br=1 then Write('Br');
	If Cl>1 then Write('Cl',Cl);If Cl=1 then Write('Cl');
	If F>1 then Write('F',F);If F=1 then Write('F');
	If I>1 then Write('I',I);If I=1 then Write('I');
	If Na>1 then Write('Na',Na);If Na=1 then Write('Na');
	If K>1 then Write('K',K);If K=1 then Write('K');
	
	If exact then 
		begin
			M:=C*12+H*1.007825037+N*14.003074008+O*15.99491464+P*30.9737634+S*31.9720718+Si*27.9769284+B*11.0093053+Br*78.9183361+Cl*34.968852729+F*18.99840325+I*126.904477+Na*22.9897697+K*38.9637079;
			Writeln(' [',M:2:10,']');
		end
	else
		begin
			M:=C*12.011+H*1.0079+N*14.0067+O*15.9994+P*30.9738+S*32.064+Si*28.086+B*79.90+Br*79.90+Cl*35.453+F*18.9984+I*126.9045+Na*22.9898+K*39.10;
			Write(' [',M:2:3,']');
			
			M:=C*12+H*1.007825037+N*14.003074008+O*15.99491464+P*30.9737634+S*31.9720718+Si*27.9769284+B*11.0093053+Br*78.9183361+Cl*34.968852729+F*18.99840325+I*126.904477+Na*22.9897697+K*38.9637079;
			Writeln(' (me=',M:2:10,')');

	{		Writeln('; ',Bondss,' bonds; ',Labelss,' labels.');}
		end;
end.
